<?php

class FS_Page
{
  private $title;
  private $messages = array();
  
  function think()
  {
    $this->title = $this->get_title();
  }
  
  function add_notice($msg)
  {
    $this->messages[] = array('type' => NOTICE_UPDATE, 'message' => $msg);
  }
  
  function add_error($msg)
  {
    $this->messages[] = array('type' => NOTICE_ERROR, 'message' => $msg);
  }
  
  function show()
  {
    $this->show_header();
    $this->show_content();
    $this->show_footer();
  }
  
  function show_header()
  {
    global $fs_page_url, $fs_tab;
    $url = $fs_page_url . '&tab=';
    ?>
    <div class="wrap nosubsub">
      <h2><?php echo $this->title; ?></h2>
      <ul class="subsubsub">
        <li>
          <a <?php if ($fs_tab == TAB_BOXES) echo 'class="current"'; ?> href="<?php echo $url; echo TAB_BOXES; ?>"><?php _e('Boxes', 'fields'); ?></a> |
        </li>
        <li>
          <a <?php if ($fs_tab == TAB_GROUPS) echo 'class="current"'; ?> href="<?php echo $url; echo TAB_GROUPS; ?>"><?php _e('Groups'); ?></a> |
        </li>
        <li>
          <a <?php if ($fs_tab == TAB_OPTIONS) echo 'class="current"'; ?> href="<?php echo $url; echo TAB_OPTIONS; ?>"><?php _e('Options'); ?></a>
        </li>
      </ul>
    
    <?php
    // notice messages
    foreach ($this->messages as $item)
    {
      $msg = $item['message'];
      if ($item['type'] == NOTICE_ERROR)
      {
        $class = 'error';
      }
      else
      {
        $class = 'updated';
      }
      
      echo "<div class='$class'><p>$msg</p></div>\n";
    }
    ?>
    
    <?php    
  }
  
  function show_footer()
  {?>
    </div>
  <?php
  }
  
}

?>