var fieldTabs = new Array();

jQuery(document).ready(function($)
{
  $(".fs-box").each(function(index, Element)
  {
    var id = $(this).attr('id');
    fieldTabs[id] = $.cookie(id);
    if ((fieldTabs[id] == null) | (fieldTabs[id] == undefined))
      fieldTabs[id] = $("#" + id + ' .tabs-panel:first').attr('id');
    $(this)
    $(this).find(".group-tab").removeClass('tabs');
    $(this).find("#" + fieldTabs[id] + '-tab').addClass('tabs');
    $(this).find(".tabs-panel").hide();
    $(this).find("#" + fieldTabs[id]).show();
    
    var minHeight = $(this).find('ul.category-tabs').height();
    $(this).find('.tabs-panel').css('min-height', minHeight);
	});

  $(".group-tab > a").click(function(event)
  {
    var group = $($(this).attr('href'));
    var id = group.attr('id');
    var box = $(this).parents('.fs-box');
    var boxId = box.attr('id');
  
    if (fieldTabs[boxId] != id) {      
      box.children(".tabs-panel").hide();
      group.show();
      var li = $(this).parent();
      li.addClass("tabs");
      li.siblings().removeClass("tabs");
      fieldTabs[boxId] = id;
      $.cookie(boxId, id);
    }
    event.preventDefault();
    return true;
  });
  
  $(".fs-multi-row").each(function()
  {
    $(this).append("<div class='sort-handle'><br /></div>");
    addSortHandleEvent($(this));
  });
  
  $("a.fs-add-more").click(function(event)
  {
    var container = $(this).parent().parent();
    addRow(container);    
    event.preventDefault();
    return true;
  });
  
  $("a.fs-remove-row").each(function(){
    addRemoveRowEvent($(this));
  });

  jQuery('.fs-sortable').sortable({handle: '.sort-handle', items: 'div.fs-multi-row', dropOnEmpty: false, revert: 100,
    update: function(event, ui){
      var item = $(ui.item);
      var parent = item.parent();
      var id = parent.siblings('th').children('label').attr('for');
      parent.children('div.fs-multi-row input').removeAttr('id');
      parent.children('div.fs-multi-row input:first').attr('id', id);
    }
  });
  
  jQuery('textarea.fs-visual').each(function(index, Element)
  {
    id = jQuery(this).attr('id');
    switchEditors.wpautop(id);
    tinyMCE.execCommand('mceAddControl', false, id);
  });  
});

function addRow(container)
{
  clone = container.children('div.fs-multi-row:first').clone();
  clone.children('input').removeAttr('id').removeAttr('value');
  container.children('.fs-add-more-wrap').before(clone);
  addSortHandleEvent(clone);
  addRemoveRowEvent(clone.children('a.fs-remove-row'));
  return clone;
}

function addSortHandleEvent(item)
{
  item.mouseenter(function()
  {
    jQuery(this).children('div.sort-handle').addClass('active');
  })
  .mouseleave(function(){
    jQuery(this).children('div.sort-handle').removeClass('active');
  });     
}

function addRemoveRowEvent(item)
{
  item.click(function(event)
  {
    item.parent().remove();
    event.preventDefault();
    return true;
  });
}